import { event, extendedEvent, IDestination, IJob, IJobConfig, IProcessor, IReporter } from './types';
export declare class Job implements IJob {
    protected processor: IProcessor;
    protected destinations: IDestination[];
    protected events: {
        [fn: string]: {
            event?: event;
            extendedEvent?: extendedEvent;
        }[];
    };
    protected reporters: IReporter[];
    protected anyEvent: ({
        event?: event;
        extendedEvent?: extendedEvent;
    })[];
    protected stopped: boolean;
    protected jobId: string;
    protected jobName?: string;
    private settingReporterEvents;
    constructor(processor: IProcessor, destinations: IDestination[], config?: IJobConfig);
    stop(message?: string): void;
    run(): Promise<void>;
    on(eventName: 'endProcessing', event?: (() => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'loadedBatch', event?: ((destinationIndex: number, data: any[]) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'processingError', event?: ((error: any) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'loadingBatchError', event?: ((destinationIndex: number, data: any[], error: any) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'loadingBatch', event?: ((destinationIndex: number, data: any[]) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'endLoadingBatch', event?: ((destinationIndex: number) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'transformedBatch', event?: ((destinationIndex: number, transformedRows: any) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'transformingBatchError', event?: ((destinationIndex: number, rows: any[], error: any) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'transformingBatch', event?: ((destinationIndex: number, rows: any[]) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'endTransformingBatch', event?: ((destinationIndex: number) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'endProcessingRow', event?: (() => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'rowGenerationError', event?: ((destinationIndex: number, row: any, error: any) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'rowGenerated', event?: ((destinationIndex: number, generatedRow: any) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'startProcessingRow', event?: ((row: any) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'startProcessing', event?: ((processor: IProcessor, destinations: IDestination[]) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'endProcessingStream', event?: ((...args: any) => Promise<any>), extendedEvent?: extendedEvent): any;
    on(eventName: 'startProcessingStream', event?: ((...args: any) => Promise<any>), extendedEvent?: extendedEvent): any;
    onAny(event?: event, extendedEvent?: extendedEvent): void;
    protected flushRows(rows: any[][]): Promise<void>;
    protected loadBatch(destinationIndex: number, destination: IDestination, data: any[]): Promise<void>;
    protected emit(eventName: string, ...args: any): Promise<void>;
}
