"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpProcessor = void 0;
var axios_1 = __importDefault(require("axios"));
var csv_parse_1 = require("csv-parse");
var Pick_1 = require("stream-json/filters/Pick");
var Parser_1 = require("stream-json/Parser");
var StreamValues_1 = require("stream-json/streamers/StreamValues");
var iconv_lite_1 = __importDefault(require("iconv-lite"));
var utils_1 = require("../utils");
var processor_1 = require("./base/processor");
var saxStream = require('sax-stream');
var HttpProcessor = /** @class */ (function (_super) {
    __extends(HttpProcessor, _super);
    function HttpProcessor(config) {
        var _this = _super.call(this, config) || this;
        _this.hasHeader = false;
        if (!config.connection) {
            throw new Error("No connection specified.");
        }
        _this.connection = config.connection;
        _this.dataFormat = config.dataFormat;
        if (config.dataFormat === 'delimited') {
            if (!config.rowSeparator) {
                throw new Error('No rowSeparator specified.');
            }
            _this.rowSeparator = config.rowSeparator;
            _this.hasHeader = !!config.hasHeader;
            _this.delimiter = config.delimiter;
            _this.qualifier = config.qualifier;
            _this.encoding = config.encoding;
        }
        else if (config.dataFormat === 'json' && config.jsonPath) {
            if (config.jsonPath instanceof RegExp) {
                _this.jsonPath = config.jsonPath;
            }
            else {
                _this.jsonPath = new RegExp(config.jsonPath);
            }
        }
        else if (config.dataFormat === 'xml' && config.saxOptions) {
            _this.saxOptions = config.saxOptions;
        }
        _this.nextRequest = config.nextRequest;
        _this.authorizationRequest = config.authorizationRequest;
        return _this;
    }
    HttpProcessor.prototype.processHttpData = function (processStream, options) {
        return __awaiter(this, void 0, void 0, function () {
            var requestStream, decodedStream, parser_1, delimitedStream, generator, requestStream, jsonStream, requestStream, xmlStream, nextOptions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.dataFormat === 'delimited')) return [3 /*break*/, 3];
                        return [4 /*yield*/, axios_1.default(__assign(__assign({}, options), { responseType: 'stream' }))];
                    case 1:
                        requestStream = _a.sent();
                        decodedStream = this.encoding ? requestStream.data.pipe(iconv_lite_1.default.decodeStream(this.encoding)) : requestStream.data;
                        parser_1 = csv_parse_1.parse({
                            quote: this.qualifier,
                            delimiter: this.delimiter,
                            record_delimiter: this.rowSeparator,
                            raw: true,
                            relax_quotes: true,
                            relax_column_count: true,
                        });
                        delimitedStream = decodedStream.pipe(parser_1);
                        generator = utils_1.getDelimitedGenerator({
                            readStream: delimitedStream,
                            hasHeader: this.hasHeader,
                        });
                        return [4 /*yield*/, processStream(generator())];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 9];
                    case 3:
                        if (!(this.dataFormat === 'json')) return [3 /*break*/, 6];
                        return [4 /*yield*/, axios_1.default(__assign(__assign({}, options), { responseType: 'stream' }))];
                    case 4:
                        requestStream = _a.sent();
                        jsonStream = requestStream.data
                            .pipe(Parser_1.parser())
                            .pipe(Pick_1.pick({ filter: this.jsonPath || '' }))
                            .pipe(StreamValues_1.streamValues())
                            .pipe(utils_1.getValueFromJSONChunk());
                        return [4 /*yield*/, processStream(jsonStream)];
                    case 5:
                        _a.sent();
                        return [3 /*break*/, 9];
                    case 6:
                        if (!(this.dataFormat === 'xml')) return [3 /*break*/, 9];
                        return [4 /*yield*/, axios_1.default(__assign(__assign({}, options), { responseType: 'stream' }))];
                    case 7:
                        requestStream = _a.sent();
                        xmlStream = requestStream.data
                            .pipe(saxStream(this.saxOptions))
                            .pipe(utils_1.removeCircularReferencesFromChunk());
                        return [4 /*yield*/, processStream(xmlStream)];
                    case 8:
                        _a.sent();
                        _a.label = 9;
                    case 9:
                        if (!this.nextRequest) return [3 /*break*/, 12];
                        return [4 /*yield*/, this.nextRequest()];
                    case 10:
                        nextOptions = _a.sent();
                        if (!nextOptions) return [3 /*break*/, 12];
                        return [4 /*yield*/, this.processHttpData(processStream, nextOptions)];
                    case 11:
                        _a.sent();
                        _a.label = 12;
                    case 12: return [2 /*return*/];
                }
            });
        });
    };
    HttpProcessor.prototype.process = function (processStream) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, utils_1.applyHttpAuthorization(this.connection, this.authorizationRequest)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.processHttpData(processStream, this.connection)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return HttpProcessor;
}(processor_1.Processor));
exports.HttpProcessor = HttpProcessor;
