"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MssqlProcessor = void 0;
var stream_1 = require("stream");
var utils_1 = require("../utils");
var database_processor_1 = require("./base/database-processor");
var MssqlProcessor = /** @class */ (function (_super) {
    __extends(MssqlProcessor, _super);
    function MssqlProcessor(config) {
        var _this = _super.call(this, config) || this;
        _this.connection = config.connection;
        return _this;
    }
    MssqlProcessor.prototype.process = function (processStream) {
        return __awaiter(this, void 0, void 0, function () {
            var done, readStream, data, db, dbRequest, processRows;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        done = false;
                        readStream = new stream_1.Readable({
                            objectMode: true,
                            read: function () {
                                return __awaiter(this, void 0, void 0, function () {
                                    var err_1, rowData;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                if (!(data.length === 0)) return [3 /*break*/, 6];
                                                if (!!done) return [3 /*break*/, 5];
                                                _a.label = 1;
                                            case 1:
                                                _a.trys.push([1, 3, , 4]);
                                                return [4 /*yield*/, processRows()];
                                            case 2:
                                                _a.sent();
                                                return [3 /*break*/, 4];
                                            case 3:
                                                err_1 = _a.sent();
                                                this.emit('error', err_1);
                                                return [3 /*break*/, 4];
                                            case 4: return [3 /*break*/, 6];
                                            case 5: return [2 /*return*/, this.push(null)];
                                            case 6:
                                                rowData = data.shift() || null;
                                                this.push(rowData);
                                                return [2 /*return*/];
                                        }
                                    });
                                });
                            },
                        });
                        data = [];
                        return [4 /*yield*/, utils_1.getDb(this.connection, 'mssql')];
                    case 1:
                        db = _a.sent();
                        dbRequest = db.request();
                        dbRequest.on('error', function (err) {
                            if (err.code !== 'ECANCEL') {
                                readStream.emit('error', err);
                            }
                        });
                        readStream.on('close', function () {
                            dbRequest.cancel();
                        });
                        dbRequest.stream = true;
                        dbRequest.query(this.query);
                        processRows = function () { return __awaiter(_this, void 0, void 0, function () {
                            var _this = this;
                            return __generator(this, function (_a) {
                                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                                        function removeListeners() {
                                            dbRequest.removeListener('row', onRow);
                                            dbRequest.removeListener('done', onDone);
                                            dbRequest.removeListener('error', onError);
                                        }
                                        function onRow(row) {
                                            return __awaiter(this, void 0, void 0, function () {
                                                return __generator(this, function (_a) {
                                                    data.push(row);
                                                    if (data.length >= 1000) {
                                                        dbRequest.pause();
                                                        removeListeners();
                                                        resolve();
                                                    }
                                                    return [2 /*return*/];
                                                });
                                            });
                                        }
                                        function onDone() {
                                            return __awaiter(this, void 0, void 0, function () {
                                                return __generator(this, function (_a) {
                                                    done = true;
                                                    removeListeners();
                                                    resolve();
                                                    return [2 /*return*/];
                                                });
                                            });
                                        }
                                        function onError(err) {
                                            return __awaiter(this, void 0, void 0, function () {
                                                return __generator(this, function (_a) {
                                                    removeListeners();
                                                    reject(err);
                                                    return [2 /*return*/];
                                                });
                                            });
                                        }
                                        return __generator(this, function (_a) {
                                            ;
                                            ;
                                            ;
                                            ;
                                            dbRequest.on('row', onRow);
                                            dbRequest.on('done', onDone);
                                            dbRequest.on('error', onError);
                                            dbRequest.resume();
                                            return [2 /*return*/];
                                        });
                                    }); })];
                            });
                        }); };
                        dbRequest.pause();
                        return [4 /*yield*/, processStream(readStream)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, utils_1.closeDbConnection(this.connection)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return MssqlProcessor;
}(database_processor_1.DatabaseProcessor));
exports.MssqlProcessor = MssqlProcessor;
